*+====================================================================
*+
*+    Source Module => E:\MULTI\MENUTO.PRG
*+
*+    Released to Public Domain.
*+
*+    Functions: Procedure __AtPrompt()
*+               Function __MenuTo()
*+
*+    Reformatted by Click! 1.10 on Aug-13-1997 at 11:40 pm
*+
*+====================================================================

/* Version 1.01 */
/* Recursive use is acceptable */

#include "COMMON.CH"
#include "INKEY.CH"

static aLevel   := {}
static nPointer := 1

*+--------------------------------------------------------------------
*+
*+    Procedure __AtPrompt()
*+
*+--------------------------------------------------------------------
*+
procedure __AtPrompt( nCol, nRow, cPrompt, cMsg )

local nMsgLen := 0

// gather message data
if valtype( cMsg ) == 'C' .and. !empty( cMsg )
   if len( cMsg ) > maxcol() + 1
      cMsg := left( cMsg, maxcol() + 1 )                    // message too long to display
   endif
   nMsgLen := max( nMsgLen, len( cMsg ) )
endif

if nPointer < 1
   nPointer := 1
endif

// add the current level empty array.
do while len( aLevel ) < nPointer
   aadd( aLevel, {} )
enddo

// add to the static array
aadd( aLevel[ nPointer ], { nCol, nRow, cPrompt, cMsg, len( cPrompt ), nMsgLen } )

// put this prompt on the screen right now
devpos( nCol, nRow )
devout( cPrompt )

return

*+--------------------------------------------------------------------
*+
*+    Function __MenuTo()
*+
*+--------------------------------------------------------------------
*+
function __MenuTo( bBlock, cVariable )

local nKey
local y
local q
local n           := eval( bBlock )
local nArrLen     := len( aLevel[ nPointer ] )
local lSetWrap    := set( _SET_WRAP )
local nMsgRow     := set( _SET_MESSAGE )
local nMaxCol     := maxcol() + 1
local lDoMessage  := nMsgRow > 0
local lGotMessage := .f.
local nMsgCol     := int( ( nMaxCol - aLevel[ nPointer ] [ len( aLevel ) ] [ 6 ] ) / 2 )
local cInColor    := setcolor()
local nComma      := at( ',', cInColor )
local cStandard   := left( cInColor, nComma - 1 )
local cEnhanced

nPointer ++

begin sequence

   if len( aLevel[ nPointer - 1 ] ) == 0
      n := 0
      break
   endif

   // grab the current system colors
   cInColor  := substr( cInColor, nComma + 1 )
   nComma    := at( ',', cInColor )
   cEnhanced := left( cInColor, nComma - 1 )

   default n to 1

   for y := 1 to nArrLen
      if valtype( aLevel[ nPointer - 1, y, 4 ] ) $ 'CB'
         lGotMessage := .t.
         exit
      endif
   next

   do while .t.

      // were there any messages?
      if lGotMessage .and. lDoMessage

         if valtype( aLevel[ nPointer - 1, n, 4 ] ) == 'B'
            // Code Block messages ( yes, they are documented! )

            eval( aLevel[ nPointer - 1, n, 4 ] )

         elseif valtype( aLevel[ nPointer - 1, n, 4 ] ) == 'C'
            // Character messages

            // set the display location
            if set( _SET_MCENTER )

               // erase the current message row
               dispbox( nMsgRow, nMsgCol, ;
                        nMsgRow, nMsgCol + aLevel[ nPointer - 1, n, 6 ], ;
                        '         ', cStandard )

               devpos( nMsgRow, ( nMaxcol - len( aLevel[ nPointer - 1, n, 4 ] ) ) / 2 )

            else

               // erase the current message row
               dispbox( nMsgRow, 0, ;
                        nMsgRow, aLevel[ nPointer - 1, n, 6 ], '         ', cStandard )

               devpos( nMsgRow, 0 )

            endif

            if len( aLevel[ nPointer - 1, n, 4 ] ) > 0

               // display the message
               devout( aLevel[ nPointer - 1, n, 4 ], cStandard )

            endif

         endif

      endif

      // save the current row
      q := n

      // highlight the prompt
      devpos( aLevel[ nPointer - 1, n, 1 ], aLevel[ nPointer - 1, n, 2 ] )
      devout( aLevel[ nPointer - 1, n, 3 ], cEnhanced )

      // wait for a keystroke
      nKey := allkey( 0 )               // substitute INKEY() or your own key handler.

      // check for keystrokes
      do case
      case nKey == K_DOWN .or. nKey == K_RIGHT
         n ++
         if n > nArrLen
            if lSetWrap
               n := 1
            else
               n := nArrLen
            endif
         endif
      case nKey == K_UP .or. nKey == K_LEFT
         n --
         if n < 1
            if lSetWrap
               n := nArrLen
            else
               n := 1
            endif
         endif
      case nKey == K_ENTER .or. nKey == K_PGUP .or. nKey == K_PGDN
         break
      case nKey == K_ESC
         n := 0
         break
      case nKey == K_HOME
         n := 1
      case nKey == K_END
         n := nArrLen
      otherwise
         // did user hit a hot key?
         for y := 1 to nArrLen
            if upper( left( ltrim( aLevel[ nPointer - 1, y, 3 ] ), 1 ) ) == upper( chr( nKey ) )
               n := y
               break
            endif
         next
      endcase

      // unhighlight the prompt
      devpos( aLevel[ nPointer - 1, q, 1 ], aLevel[ nPointer - 1, q, 2 ] )
      devout( aLevel[ nPointer - 1, q, 3 ], cStandard )

   enddo

end sequence

nPointer --

asize( aLevel, nPointer - 1 )

return n

*+ EOF: MENUTO.PRG
