*+====================================================================
*+
*+    Source Module => E:\MULTI\RANDOMIZ.PRG
*+
*+    Released to Public Domain.
*+
*+    Functions: Function RANDOMIZE()
*+               Function random()
*+
*+    Reformatted by Click! 1.10 on Aug-13-1997 at 11:40 pm
*+
*+====================================================================

static seed := - 1

*+--------------------------------------------------------------------
*+
*+    Function RANDOMIZE()
*+
*+    Called from ( scrnblnk.prg )   2 - procedure scrnblnk()
*+
*+--------------------------------------------------------------------
*+
function RANDOMIZE( nLimit )

// returns a random number between 1 and nLimit, inclusive
return int( random() * nLimit ) + 1

*+--------------------------------------------------------------------
*+
*+    Function random()
*+
*+    Called from ( randomiz.prg )   1 - function randomize()
*+
*+--------------------------------------------------------------------
*+
function random()

local p := 335544319                    // This is just a lucky prime number
local x := ( 2 ^ 31 ) - 1               // This is the distribution factor
local y := x / p
local z := x % p

if seed == - 1
   seed := ( seconds() * day( date() ) * month( date() ) * year( date() ) ) % x
endif

seed := abs( p * ( seed % y ) - z * ( seed / y ) ) % x

return ( seed - 1 ) / ( x - 2 )

*+ EOF: RANDOMIZ.PRG
